#include <iostream>

using namespace std;

int a[200000];
int konok[200000];
int prelaz[200000];

//konok = KOliko Nije OK

int main()
{
    int n,q;
    bool z=true;
    cin>>n;
    int i;
    cin>>a[0];
    konok[0]=0;
    int dp=0;
    for(i=1;i<n;i++){
        cin>>a[i];
        if(a[i]!=2){
            z=false;
        }
        if(a[i-1]>a[i]){
            konok[i]=konok[i-1]+1;
            prelaz[dp]=i-1;
            dp++;
        }
        else{
            konok[i]=konok[i-1];
        }
    }
    if(z){
        cin>>q;
        int l,r;
        int pr,po;
        for(i=0;i<q;i++){
            cin>>l>>r;
            l--;
            r--;
            pr=konok[r]-konok[l];
            if(pr>1){
                cout<<"NE"<<endl;
            }
            else{
                po=prelaz[(konok[l])];
                if((po>=1 && a[po-1]>=po)&&(po<=r-2 && a[po+2]<a[po])){
                    cout<<"NE"<<endl;
                }
                else{
                    cout<<"DA"<<endl;
                }
            }
        }
    }
    else{
        cin>>q;
        int l,r;
        int pr,po;
        for(i=0;i<q;i++){
            cin>>l>>r;
            l--;
            r--;
            pr=konok[r]-konok[l];
            if(pr>1){
                cout<<"NE"<<endl;
            }
            else{
                po=prelaz[(konok[l])];
                if((po>=1 && a[po-1]==2)&&(po<=r-2 && a[po+2]==1)){
                    cout<<"NE"<<endl;
                }
                else{
                    cout<<"DA"<<endl;
                }
            }
        }
    }
    return 0;
}